com.thinkaurelius.titan.diskstorage.keycolumnvalue

## Interface StoreManager

- All Known Subinterfaces:
    CustomizeStoreKCVSManager, KeyColumnValueStoreManager, KeyValueStoreManager, OrderedKeyValueStoreManager
  All Known Implementing Classes:
    AbstractStoreManager, DistributedStoreManager, ExpectedValueCheckingStoreManager, InMemoryStoreManager, KCVSManagerProxy, LocalStoreManager, OrderedKeyValueStoreManagerAdapter, TTLKVCSManager

      public interface StoreManager

  Generic interface to a backend storage engine.
  Author:
    Matthias Broecheler (me@matthiasb.com)

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `StoreTransaction` | `beginTransaction(BaseTransactionConfig config)` Returns a transaction handle for a new transaction according to the given configuration.
    `void` | `clearStorage()` Deletes and clears all database in this storage manager.
    `void` | `close()` Closes the Storage Manager and all databases that have been opened.
    `StoreFeatures` | `getFeatures()` Returns the features supported by this storage manager
    `List<KeyRange>` | `getLocalKeyPartition()` Returns `KeyRange`s locally hosted on this machine.
    `String` | `getName()` Return an identifier for the StoreManager.

- - ### Method Detail

    - #### beginTransaction

          StoreTransaction beginTransaction(BaseTransactionConfig config)
                                            throws BackendException

      Returns a transaction handle for a new transaction according to the given configuration.
      Returns:
        New Transaction Handle
      Throws:
        `BackendException`

    - #### close

          void close()
                     throws BackendException

      Closes the Storage Manager and all databases that have been opened.
      Throws:
        `BackendException`

    - #### clearStorage

          void clearStorage()
                            throws BackendException

      Deletes and clears all database in this storage manager.

      ATTENTION: Invoking this method will delete ALL your data!!
      Throws:
        `BackendException`

    - #### getFeatures

          StoreFeatures getFeatures()

      Returns the features supported by this storage manager
      Returns:
        The supported features of this storage manager
      See Also:
        `StoreFeatures`

    - #### getName

          String getName()

      Return an identifier for the StoreManager. Two managers with the same name would open databases that read and write the same underlying data; two store managers with different names should be, for data read/write purposes, completely isolated from each other.

      Examples:
      - Cassandra keyspace
      - HBase tablename
      - InMemoryStore heap address (i.e. default toString()).
      Returns:
        Name for this StoreManager

    - #### getLocalKeyPartition

          List<KeyRange> getLocalKeyPartition()
                                              throws BackendException

      Returns `KeyRange`s locally hosted on this machine. The start of each `KeyRange` is inclusive. The end is exclusive. The start and end must each be at least 4 bytes in length.
      Returns:
        A list of local key ranges
      Throws:
        `UnsupportedOperationException` - if the underlying store does not support this operation. Check `StoreFeatures.hasLocalKeyPartition()` first.
        `BackendException`

Copyright © 2012–2014. All rights reserved.